Unit QSF3R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QSF3R(var INT1 :Real; var INT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                L1 :Integer; L2 :Integer);

implementation

procedure QSF3R(var INT1 :Real; var INT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; var E :Real;
                L1 :Integer; L2 :Integer);
var
U,V,X,BB,IERR :Integer;
I,J,J1,J2,K,L,M,C,D,G,Q1,BA,W,Z2,EPS,H,Z1,P,BK,BJ,BO,BM,BL,BD,BN,BR,
   BS,BT,BV,BF,Q,R,S,BP,BQ,E1 :Real;
NI,Y,Z :Boolean;
BC :Array [0..4] of Real;
BG :Array [0..4] of Real;
BH :Array [0..4] of Real;
BI :Array [0..4] of Real;
BU :Array [0..6] of Real;
const
T33 :Real = 0.33;
SYS093 :Real = 0.999999;
TOF :Real = 0.1555555;
TSO :Real = 0.7111111;
TDS :Real = 0.2666666;
HMIN :Real = 1.0E-4;
SYS051 :Real = 1.1920928E-7;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_50,_40,_41;
begin
V := 2;
Y := True;
X := 1;
E1 := E;
C := 0.0;
D := 0.0;
G := 0.0;
I := 0.0;
if ( B-100.0 ) < 0
 then goto _4
 else if ( B-100.0 ) > 0
       then goto _1
       else goto _1;
_1:
if ( A+100.0 ) < 0
 then goto _2
 else if ( A+100.0 ) > 0
       then goto _3
       else goto _2;
_2:
Y := False;
X := -1;
K := B;
E := E/2.0;
B := A;
A := 0.0;
_3:
goto _27;
_4:
X := -1;
Q1 := A;
A := B;
B := Q1;
goto _27;
_5:
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _6;
BA := A;
A := B;
B := BA;
_6:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _7;
J1 := 0.0;
J2 := 0.0;
goto _26;
_7:
Z2 := E/W;
EPS := Abs(E);
H := 1.0;
Z1 := EPS/W;
P := 0.0;
J1 := 0.0;
J2 := 0.0;
_8:
BK := H/2.0;
BJ := W*BK;
BO := BJ*RO;
BM := H*0.25;
for BB:=1 to 5 do
 begin
  BG[BB-1] := F(A+W*(P+BM*(BB-1)));
_9:
 end;
_10:
if ( (L1+L2)  < 1.5  ) and ( BO  <= 0.25 ) 
 then goto _11;
BL := Abs(BG[0]+BG[4]-4.0*(BG[1]+BG[3])+6.0*BG[2]);
goto _13;
_11:
BD := (A+W*(P+BK))*RO+FI;
for BB:=1 to 5 do
 begin
  BH[BB-1] := BG[BB-1]*Sin(BD);
  BI[BB-1] := BG[BB-1]*Cos(BD);
_12:
 end;
BD := BH[0]+BH[4]-4.0*(BH[1]+BH[3])+6.0*BH[2];
BL := BI[0]+BI[4]-4.0*(BI[1]+BI[3])+6.0*BI[2];
BL := EMax1(L1*Abs(BD),L2*Abs(BL));
_13:
BL := BL*BK*0.42;
if ( H  <= HMIN ) 
 then goto _50;
if ( Abs(BL)-Z1 ) < 0
 then goto _17
 else if ( Abs(BL)-Z1 ) > 0
       then goto _14
       else goto _14;
_14:
H := H/2.0;
if ( H  > SYS051*P ) 
 then goto _16;
_15:
P := P+H*2.0;
H := H*2.0;
goto _17;
_16:
BG[4] := BG[2];
BG[2] := BG[1];
BK := H*0.5;
BO := W*BK*RO;
BM := H*0.25;
BN := P+BM;
BG[1] := F(A+W*BN);
BG[3] := F(A+W*(BN+BK));
goto _10;
_17:
BD := (A+W*(P+BK))*RO+FI;
BR := Sin(BD);
BS := Cos(BD);
BJ := W*BK;
BT := RO*BJ;
BU[3] := Sin(BT);
BU[4] := Cos(BT);
if ( BT-T33 ) < 0
 then goto _18
 else if ( BT-T33 ) > 0
       then goto _19
       else goto _18;
_18:
BV := BT*0.5;
BU[5] := Sin(BV);
BU[6] := Cos(BV);
BC[0] := TDS;
BC[1] := TSO*BU[6];
BC[2] := TOF*BU[4];
BC[3] := TSO*BU[5];
BC[4] := TOF*BU[3];
goto _20;
_19:
BU[0] := 1.0/BT;
BU[1] := BU[0]*BU[0];
BU[2] := BU[1]*BU[1];
BC[0] := 4.0*BU[1]*(BU[0]*(48.0*BU[1]-19.0)*BU[3]+3.0*(1.0-
    16.0*BU[1])*BU[4]);
BC[1] := 32.0*BU[1]*(BU[0]*(5.0-12.0*BU[1])*BU[3]-(1.0-12.0*
    BU[1])*BU[4])/3.0;
BC[2] := BU[0]*((3.0-46.0*BU[1]+96.0*BU[2])*BU[3]+2.0*BU[0]*
    (7.0-48.0*BU[1])*BU[4])/3.0;
BC[3] := -16.0*BU[1]*((1.0-3.0*BU[1])*BU[3]+3.0*BU[0]*BU[4])/
    3.0;
BC[4] := BU[0]*(BU[0]*(11.0-24.0*BU[1])*BU[3]-3.0*(1.0-8.0*
    BU[1])*BU[4])/3.0;
_20:
BP := BC[0]*BG[2]+BC[1]*(BG[1]+BG[3])+BC[2]*(BG[0]+BG[4]);
BQ := BC[3]*(BG[3]-BG[1])+BC[4]*(BG[4]-BG[0]);
J1 := J1+(BR*BP+BS*BQ)*BK;
J2 := J2+(BS*BP-BR*BQ)*BK;
P := P+H;
BF := 1.0-P;
if ( 1.0+BF/64.0-1.0 ) < 0
 then goto _25
 else if ( 1.0+BF/64.0-1.0 ) > 0
       then goto _21
       else goto _25;
_21:
BG[0] := BG[4];
if ( BL-Z1/32.0 ) < 0
 then goto _22
 else if ( BL-Z1/32.0 ) > 0
       then goto _23
       else goto _23;
_22:
H := 2.0*H;
_23:
if ( H-BF ) < 0
 then goto _8
 else if ( H-BF ) > 0
       then goto _24
       else goto _8;
_24:
H := BF;
goto _8;
_25:
J1 := J1*W;
J2 := J2*W;
if (  not ( (NI) ) ) 
 then goto _26;
BA := B;
B := A;
A := BA;
_26:
case U of
 1: goto _30;
 2: goto _34;
end;
_27:
J := B;
L := A;
B := L+(V*X);
if ( (B-J)*(X) ) < 0
 then goto _29
 else if ( (B-J)*(X) ) > 0
       then goto _28
       else goto _29;
_28:
B := J;
_29:
U := 1;
goto _5;
_30:
INT1 := J1;
INT2 := J2;
Q := EMax1(Abs(J1)*(L1),Abs(J2)*(L2));
_31:
Z := False;
R := Q;
A := B;
B := L+(B-L)*(V);
if ( (B-J)*(X) ) < 0
 then goto _33
 else if ( (B-J)*(X) ) > 0
       then goto _32
       else goto _33;
_32:
B := J;
_33:
U := 2;
goto _5;
_34:
INT1 := INT1+J1;
INT2 := INT2+J2;
Q := EMax1(Abs(J1)*(L1),Abs(J2)*(L2));
if ( Q  = 0.  ) and ( R  = 0.0 ) 
 then goto _36;
if ( Q-SYS093*R ) < 0
 then goto _35
 else if ( Q-SYS093*R ) > 0
       then goto _31
       else goto _31;
_35:
S := Q/R;
S := Q*S/(1.0-S);
if ( S-E ) < 0
 then goto _36
 else if ( S-E ) > 0
       then goto _31
       else goto _31;
_36:
if (  not ( (Z) ) ) 
 then goto _37;
goto _38;
_37:
Z := True;
_38:
A := L;
B := J;
C := C+INT1;
G := G+INT2;
D := C;
I := G;
if ( Y ) 
 then goto _41;
if ( X+1 ) < 0
 then goto _39
 else if ( X+1 ) > 0
       then goto _40
       else goto _39;
_39:
M := B;
B := K;
X := 1;
goto _27;
_50:
IERR := 65;
E := E1;
UTQS10(IERR,14);
goto _41;
_40:
A := M;
E := 2.0*E;
_41:
INT1 := D;
INT2 := I;
end;

end.
